<?php
if( !function_exists( "modal_theme_flat_discount" ) ) {
	function modal_theme_flat_discount( $atts, $content = null ){
		/**
		 * Define Variables
		 */
		global $cp_form_vars;

		$style_id = $settings_encoded = '';
		extract(shortcode_atts(array(
			'style_id'			=> '',
			'settings_encoded'	=> '',
	    ), $atts));

		$settings = base64_decode( $settings_encoded );
		$style_settings = unserialize( $settings );

		foreach( $style_settings as $key => $setting ) {
			$style_settings[$key] = apply_filters('smile_render_setting',$setting);;
		}
		
		unset($style_settings['style_id']); 

		//	Generate UID
		$uid		= uniqid();
		$uid_class	= 'content-'.$uid;

		$individual_vars = array(
			"uid"       	=> $uid,
			"uid_class" 	=> $uid_class,
			"style_class"	=> "cp-flat-discount"
		);		

		/**
		 * Merge short code variables arrays
		 *
		 * @array 	$individual_vars		Individual style EXTRA short-code variables
		 * @array 	$cp_form_vars			CP Form global short-code variables
		 * @array 	$style_settings			Individual style short-code variables
		 * @array 	$atts					short-code attributes
		 */
		$all = array_merge(
			$individual_vars,
			$cp_form_vars,
			$style_settings,
			$atts
		);

		/**
		 *	Extract short-code variables
		 *
		 *	@array 		$all 		 All merged arrays
		 *	@array 		array() 	 Its required as per WP. Merged $style_settings in $all.
		 */

		$a = shortcode_atts( $all , array() );

        /** = Style - individual options
		 *-----------------------------------------------------------*/
	
		$body_inner_style       = generateBorderCss($a['border']);

		/** = Before filter
		 *-----------------------------------------------------------*/
		apply_filters_ref_array('cp_modal_global_before', array( $a ) );

?>
	<!-- BEFORE CONTENTS -->

	<div class="cp-row">
		<div class="cp-modal-body-inner" style="<?php echo esc_attr( $body_inner_style ); ?>">
	  		<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 cp-text-container">
	       		<div class="cp-title-container <?php if( trim( $a['modal_title1'] ) === '' ) { echo 'cp-empty'; } ?>">
	       			<h2 class="cp-title cp_responsive" style="color: <?php echo esc_attr( $a['modal_title_color'] ); ?>;"><?php echo do_shortcode( html_entity_decode( stripcslashes( $a['modal_title1'] ) ) ); ?></h2>
	      		</div>
	      		<div class="cp-desc-container <?php if( trim( $a['modal_short_desc1'] ) === '' ) { echo 'cp-empty'; } ?>">
	        		<div class="cp-description cp_responsive" style="color: <?php echo esc_attr( $a['modal_desc_color'] ); ?>;"><?php echo do_shortcode( html_entity_decode( stripcslashes( $a['modal_short_desc1'] ) ) ); ?></div>
	      		</div>
	         	<div class="cp-form-container">	          		
	          		<?php
	             		/**
						 * Embed CP Form
						 */
						apply_filters_ref_array('cp_get_form', array( $a ) );
					?>
				</div>
                <div class="cp-info-container <?php if( trim( $a['modal_confidential'] ) === '' ) { echo 'cp-empty'; } ?>" style="color: <?php echo esc_attr( $a['tip_color'] ); ?>;">
                	<?php echo do_shortcode( html_entity_decode( $a['modal_confidential'] ) ); ?>
                </div>
        	</div>		            	
		</div> <!-- .cp-modal-body-inner close -->	          	
	</div> <!-- cp-row close  -->
	<!-- AFTER CONTENTS -->
<?php
		/** = After filter
		 *-----------------------------------------------------------*/
		apply_filters_ref_array('cp_modal_global_after', array( $a ) );

	   return ob_get_clean();
	}
}